<? 
	$arrForms = $form->selectForms($arrProject['idProject']);
?>
<!-- JS Charts Lib -->
<script src="js/chart.js"></script>
<style>
	.chart-select {width:100%;font-weight:bold;height:30px;text-align:left;margin-bottom:5px;}
	.btn-chart-type {position:relative;top:-4px;}
	.chart{background-color: #FFFFFF;padding: 3px;border: solid 1px black;}
</style>
<div class="sessionTitle">
    <i class="fa fa-pie-chart"></i><span class="hidden-phone"> <? echo $_SESSION['strHomeMapButtonCharts']; ?></span>
    <span style="float:right;position:relative;top:-4px;display:inline-block">
		<!-- Date Range -->
		<input id="dtChartDateFrom" name="dtChartDateFrom" type="date" onChange="chartChartLoad();" title="<? echo $_SESSION['stradmStatsProjectCreationDate'] . ': ' . $arrProject['strDateCreation']; ?>" value="<? echo $_COOKIE['dtDateFrom'] ? $_COOKIE['dtDateFrom'] : date("Y-m-d", strtotime("-1 month", time())); ?>"> <?=$_SESSION['strGlobalTo']?> 
		<input id="dtChartDateTo" name="dtChartDateTo" type="date"  onChange="chartChartLoad();" value="<? echo $_COOKIE['dtDateTo'] ? $_COOKIE['dtDateTo'] : date('Y-m-d', time()); ?>">
		
		<!-- Chart Mode -->
		<input type="hidden" id="strChartType" name="strChartType" value="bar">
		<span class="btn-chart-type">
		<a id="btnChartLine" class="btn" onClick="chartChartLoad('line');"><i class="fa fa-line-chart" title="Line Chart"></i></a>
		<a id="btnChartBar" class="btn" onClick="chartChartLoad('bar');"><i class="fa fa-bar-chart" title="Bar Chart"></i></a>
		<a id="btnChartPie" class="btn" onClick="chartChartLoad('pie');"><i class="fa fa-pie-chart" title="Pie Chart"></i></a>
		</span>
	</span>
</div>
<!-- Form -->
<select id="cmbForm" name="cmbForm" class="btn chart-select" onChange="chartFormFieldsLoad();">
<? foreach($arrForms as $arrForm) { ?>
<option value="<?=$arrForm['idForm']?>"><?=$arrForm['strName']?></option>
<? } ?>
</select>
<!-- Form Field -->
<select id="cmbFormFields" name="cmbFormFields" class="btn chart-select" onChange="chartChartLoad();"></select>
<!-- Chart Canvas -->
<div id="divChart" style="padding:5px;display:none">
	<a id="btnChartSave" class="btn btn-info" href="#" data-rel="tooltip" title="<?=$_SESSION['strChartsSaveChart']?>" style="cursor:pointer;position:absolute;margin-top:3px;margin-left:3px;display:none" onClick="chartSave();"><i class="fa fa-save"></i></a>
	<div id="divLoading" style="width:100%;text-align:center;display:none;"><img src="img/loading.gif"><?=$_SESSION['strGlobalLoading']?>...</div>
</div>
<script>
$('#cmbForm').focus();
function chartFormFieldsLoad(){
	var idForm = document.getElementById('cmbForm').value;
	var cmbFormField = document.getElementById('cmbFormFields');
	if (! idForm > 0) return;
	var result = $.ajax({
		url: 'ajax.php?chrAction=FFS&idForm=' + idForm
	}).always(function() {
		var arrResult 	= JSON.parse(result.responseText);
		// Clear Form Combo Items
		for (var i=cmbFormFields.options.length-1;i>=0;i--) { cmbFormFields.remove(i); 	}
		// Print Form Fields
		for (var i=0;i<arrResult['arrFields'].length;i++) {
			var opt = document.createElement('option');
			opt.value = arrResult['arrFields'][i]['idFormField'];
			opt.text = arrResult['arrFields'][i]['strName'];
			opt.setAttribute("idFormFieldType", arrResult['arrFields'][i]['idFormFieldType']);
			cmbFormFields.add(opt);
		}
		$('#cmbFormFields').focus();
		if (cmbFormFields.value > 0) { chartChartLoad(); }
	});
}

function chartChartLoad(strChartType){
	if (strChartType != null) {
		document.getElementById('strChartType').value = strChartType;
	}
	var divLoading = document.getElementById("divLoading");
	var divChart = document.getElementById("divChart");
	var idFormField = document.getElementById('cmbFormFields').value;
	var btnChartSave = document.getElementById("btnChartSave");
	var strChartType = document.getElementById('strChartType').value;
	divLoading.style.display = 'block';
	btnChartSave.style.display = 'none';
	document.getElementById('btnChartLine').className = 'btn' + (strChartType == 'line' ? ' btn-success' : '');
	document.getElementById('btnChartBar').className = 'btn' + (strChartType == 'bar' ? ' btn-success' : '');
	document.getElementById('btnChartPie').className = 'btn' + (strChartType == 'pie' ? ' btn-success' : '');
	result = $.ajax({
		url: 'ajax.php?chrAction=CCL' + 
			'&idFormField=' + idFormField +
			'&dtDateFrom=' + document.getElementById('dtChartDateFrom').value +
			'&dtDateTo=' + document.getElementById('dtChartDateTo').value +
			'&strChartType=' + document.getElementById('strChartType').value
	}).always(function() {
		divLoading.style.display = 'none';
		var x = document.getElementsByClassName("chart");
		for (var i = 0; i < x.length; i++) {
			x[i].remove();
		}
		if (! result.responseText) {
			return;
		}
		var arrResult = JSON.parse(result.responseText);
		if (arrResult['arrLabels'].length == 0) {
			return;
		}
		var config = {
			type: arrResult['strType'],
			data: {
				datasets: arrResult['arrDatasets'],
				labels: arrResult['arrLabels']
			},
			options: {
				responsive: true,
				maintainAspectRatio: false,
				stacked: false,
				title:{
					display: true,
					text: arrResult['strTitle']
				}
			}
		};
		// Force Pain Backrground as White
		Chart.plugins.register({
		  beforeDraw: function(chartInstance) {
			var ctx = chartInstance.chart.ctx;
			ctx.fillStyle = "white";
			ctx.fillRect(0, 0, chartInstance.chart.width, chartInstance.chart.height);
		  }
		});
		var cvs = document.createElement('canvas');
		cvs.id = 'cvsChart';
		cvs.className = 'chart';
		divChart.style.height = ($(window).height() - 240) + "px";
		divChart.appendChild(cvs);
		var ctx = cvs.getContext("2d");
		var chart = new Chart(ctx, config);
		divChart.style.display = 'block';
		btnChartSave.style.display = 'block';
	});
}

function chartSave(){
	window.open('about:blank','PNG').document.write("<img src='" + document.getElementById("cvsChart").toDataURL("image/png") + "' alt='PNG'/>");
}

$(document).ready( function () {
	chartFormFieldsLoad();
});
</script>