<?php
  // Documentation Page: https://developers.facebook.com/docs/graph-api/using-graph-api/v2.0#search
  // Post return fields (DEPRECATED) - https://developers.facebook.com/docs/reference/api/post/
  // Graph API Explorer: https://developers.facebook.com/tools/explorer?method=GET&path=search%3Fq%3Dbotafogo%26type%3Dplace&version=v2.7
  // Example: https://graph.facebook.com/search?q=botafogo&type=place&access_token=EAACEdEose0cBAM66l57139E42cth7aDVjdr91cZA62YrDwovM07JO4LZAWBc1AsL8IDAwchQp31ADmEznrfKtcSrgmHpqnabNdm5865JkU5RqK1kbJgoEGFLJ2C2f9xVNCZAwD8wBgb9sf9iNbnVZCYXwuXJxknmzZCACB6GaXNjmiXv8r9zu
  // Account details
  $accountUserEmail 	= "colaboracaosocial@gmail.com";
  $accountUserPassword	= "Colabora2.0";
  $appID				= "142494312821896";
  $appSecret			= "6567e75ebbe4531e1115ed92bdc7b6d8";
  include_once '../engine/strings.php';
  $strings = new Strings();
  header('Content-type: text/xml');
  set_time_limit(120);
  $arrResult = array();
  // First getting a access token
  $data = $strings->processUrl('https://graph.facebook.com/oauth/access_token?type=client_cred&client_id=' . $appID . '&client_secret=' . $appSecret);
  $strAccessToken = substr($data, strpos($data, '=')+1, 200);
  $strUrl = 'https://graph.facebook.com/v1.0/search?&access_token=' . $strAccessToken . '&' . $_SERVER["QUERY_STRING"] .'&type=' . ($_GET['type'] ? $_GET['type'] : 'place');
$strings->log($strUrl, '../tmp/out.txt', true);
  $data = $strings->processUrl($strUrl);
  $json = $strings->objectify('json', $data);
  // Loop for each result
  foreach($json->{"data"} as $entry) {
	$entry->{'id'} = $entry->{'id'};
	$entry->{'date'} = date("Y-m-d H:i:s");
	$entry->{'coordinates'} = $entry->{'location'}->{'longitude'} . ',' . $entry->{'location'}->{'latitude'};
	$arrResult['record'][] = $entry;
  }
  echo utf8_decode($strings->strArrayToXML2($arrResult));
?>