<?php
	// Documentation Page: http://earthquake.usgs.gov/fdsnws/event/1/ 
	// Example: http://earthquake.usgs.gov/fdsnws/event/1/query?format=xml&starttime=2016-06-21&endtime=2016-06-22&minmagnitude=5
	include_once '../engine/strings.php';
	$strings = new Strings();
	header('Content-type: text/xml');
	set_time_limit(120);
	$arrResult = array();
	$strUrl  = 'http://earthquake.usgs.gov/fdsnws/event/1/query?format=geojson&' . $_SERVER["QUERY_STRING"];
	$data = $strings->processUrl($strUrl);
	$json = $strings->objectify('json', $data);
	foreach($json->{"features"} as $entry) {
		$entry->{'depth_km'} = $entry->{'geometry'}->{'coordinates'}[2];
		$entry->{'id'} = $entry->{'id'};
		$entry->{'date'} = date("Y-m-d H:i:s", $entry->{'properties'}->{'time'}/1000);
		$entry->{'coordinates'} = $entry->{'geometry'}->{'coordinates'}[0] . ',' . $entry->{'geometry'}->{'coordinates'}[1];
		$arrResult['record'][] = $entry;
	}
	echo $strings->strArrayToXML2($arrResult);
?>