<div id="sessionTitle"><i class="<?=$datasource->strDefaultIcon?>"></i><span class="hidden-phone"> <? echo $_SESSION['stradmManageDatasources']; ?> - Developer</span></div>
<div id="sessionTitle2"></div>
<h3>Instruções para desenvolvedores de scripts PHP para a extração de conteúdo de Fontes de Informações:</h3>
<style>li {list-style:circle}</style>
<?
  $strFields = '';
  $i = 0;
  foreach($datasource->arrDefaultFields as $arrDefaultField) {
	$strFields .=  
	'<li>' . 
	  ($arrDefaultField['blnMandatory'] == 1 ? '<span style="color:#FF0000;font-weight:bold;cursor:help" data-rel="tooltip"> [MANDATORY]</span> ' : '') . 
	  '&lt' . $arrDefaultField['strName'] . '&gt ' .
	  $arrDefaultField['strDescription'] . '. Eg.: ' . $arrDefaultField['strExample'] . 
	  ($i < count($datasource->arrDefaultFields)-1 ? '<br>' : '') .
	'</li>';
	$i++;
  }
  
  $strGET = '';
  foreach($datasource->arrDefaultGETParameters as $item) {
	$strGET .=  '<li>$_GET[\'' . $item['strName'] . '\']' . ' - ' . $item['strDescription'] . '</li>';
  }
?>
<ul>
    <li>Parâmetros padrão de requisição: <ul><?=$strGET?></ul></li>
    <li>Atributos de um retorno &ltrecord&gt: <ul><?=$strFields?></ul></li>
    <li>O retorno XML deve conter os registros aninhados segunda as seguintes tags para identificar cada registro de publicação (<a href="#script-result">exemplo</a>): 
<pre><? echo htmlentities('
<?xml version="1.0" encoding="ISO-8859-1"?>
<records>
  <record>
	<id>abc123</id>
	<date>2016-12-01 01:23:45</date>
	<shapetype>1</shapetype>
	<color>ff0000</color>
	<coordinates>-43.123456,-23.123456</coordinates>
	<files>http://www.viconsaga.com.br/images/abc.jpg,http://www.viconsaga.com.br/images/efg.jpg</files>
	<field1>value 1</field1>
	<field2>value 2</field1>
	...
	<fieldn>value n</fieldn>
  </record>
  <record>
	<id>abc123</id>
	<date>2016-12-31 12:34:56</date>
	<shapetype>3</shapetype>
	<color>aabbcc</color>
	<coordinates>-56.123456,-13.123456 -26.343456,-23.123456 -86.123456,-33.123456</coordinates>
	<files>http://www.viconsaga.com.br/images/hij.jpg,http://www.viconsaga.com.br/images/klm.jpg</files>
	<field1>value 3</field1>
	<field2>value z</field1>
	...
	<fieldn>value n</fieldn>
  </record>
</records>'); ?></pre>
	</li>
</ul>
<p>O código a seguir representa um modelo de código de script PHP para coleta de publicações de fontes de informação:</p>
<?
	ini_set( "display_errors", 0);
	$strScriptFilePath = '../datasource/usgs.php';
	if($fh = fopen($strScriptFilePath, 'r')){
		$strFileContent = fread($fh, filesize($strScriptFilePath));
		fclose($fh);
	}
	// Removing password and login
	$strFileContent = htmlentities($strFileContent);
	echo '
	<div style="background:#ffffff;width:auto;height:300px;overflow-y:scroll;overflow-x:hidden;border:solid gray;border-width:.1em .1em .1em .8em;padding:.2em .6em;">
		<pre style="margin:0;line-height:125%;"><span style="color: #008800; font-weight: bold">Código Fonte</span>
			<br>' . $strFileContent . '
		</pre>
	</div>';
?>
<p>
O código a seguir representa um modelo de retorno da função getMessages no formato XML.</p>
<div id="script-result"></div>
<?
	$dom = new DOMDocument("1.0");
	$dom->preserveWhiteSpace = false;
	$dom->formatOutput = true;
	$strInfoSourceName = 'USGS';
	$dom->load('admDataSourcesScripts.xml');
	$strXMLResult = $dom->saveXml();
	$strXMLResult = htmlspecialchars($strXMLResult);
	echo '
	<div style="background:#ffffff;width:auto;height:500px;overflow-y:scroll;overflow-x:hidden;border:solid gray;border-width:.1em .1em .1em .8em;padding:.2em .6em;">
		<pre style="margin:0;line-height:125%;"><span style="color: #008800; font-weight: bold">Resultado XML para "' . $strInfoSourceName . '"</span><br>' . $strXMLResult . '
		</pre>
	</div>';
	ini_set( "display_errors", 1);
?>
<!--<div id="imagem">
	<img src="img/" name="imagemShot" width="368" height="178" border="0" id="imagemShot">
	<div id="imagemLegenda">Exemplo de resultado no formato XML de uma requisição da função getMessages()</div>
</div>-->