<?
	include_once 'engine/strings.php';
	$strings = new Strings();
	include_once 'engine/database.php';
	$database = new Database();
	include_once 'engine/project.php';
	$project = new Project($database);
	// Loading strings according to selected language
	$arrProject = $project->selectProjects($_GET['idProject']);
	$arrProject = $arrProject[0];
	$strings->loadLanguage(($_SESSION['strSiteLanguage'] != '' ? $_SESSION['strSiteLanguage'] : $arrProject['strLanguageCode']));
?>
<script src="js/jquery-1.11.1.js"></script>
<script src="js/fileupload/js/jquery.ui.widget.js"></script>
<script src="js/fileupload/js/jquery.fileupload.js"></script>
<script src="js/main.js"></script>
<link href="css/bootstrap.css" rel="stylesheet">
<style>	
	.marker {
		max-width:50px;
		height:50px;
		display:inline-block;
		text-align:center;
		vertical-align: middle;
		position: relative; 
		margin:2px;
		cursor:pointer;
		zoom:100%;
	}
	
	.marker:hover {
		zoom:105%;
		font-weight:bold;
	}
</style>
<body style="text-align:center;margin:0px;padding:0px">
    <div style="width:100%;text-align:center"><input type="text" id="strSearch" placeholder="<? echo $_SESSION['strMarkersSearchGoogleImages']; ?>..." style="width:90%" onKeyDown="if(event.keyCode=='13') {googleSearchImages();}"/></div>
    <div id="divSearchResults" style="width:99%;text-align:center;background-color:#F5F5F5;border:solid 1px #888888; display:none"></div>
    <input id="fuMarker" type="file" name="files[]" style="display:none" multiple>
    <div id="markersContainer"></div>
</body>
<script>
	function googleSearchImages() {
		var strResult = '';
		document.getElementById('divSearchResults').style.display = "none";
		document.getElementById('divSearchResults').innerHTML = '';
		var result = $.ajax({
			url: 'https://www.googleapis.com/customsearch/v1?' +
				'key=<? echo $strings->GoogleAPIKey; ?>' +
				'&cx=001403345137095664527:_w4juo3tn_s' +
				'&q=' + document.getElementById('strSearch').value +
				'&searchType=image' +
				'&fileType=png' +
				'&alt=json'
		}).always(function() {
			var arrResult = JSON.parse(result.responseText);
			var items = arrResult['items'];
			for (var i=0;i<items.length;i++) {
				strResult += '<img src="' + items[i]['link'] + '" class="marker" onClick="markerSelect(0, this, true);"> ';
			}
			document.getElementById('divSearchResults').style.display = "block";
			document.getElementById('divSearchResults').innerHTML = strResult;
		});
	}
	
    // Manipulating Files Upload
    $(function () {
        // Change this to the location of your server-side upload handler:
        var url = 'js/fileupload/index.php';
        $('#fuMarker').fileupload({
            url: url,
            dataType: 'json',
            done: function (e, data) {
                // For multiple files...
                $.each(data.result.files, function (index, file) {
                    if (! blnIsImage(file.name)) { 
						showInfoAlert('<? echo $_SESSION['strErrorInvalidFormat']; ?> JPG, PNG, GIF, BMP');
                        return;
                    }
                    markerFileCopyUploaded(file.name);
                });
                document.getElementById('ContainerBar').style.display='none';
            },
            start: function(e) {
                $('#bar').css('width','0%');
                document.getElementById('ContainerBar').style.display='block';
            },
            progressall: function (e, data) {
                var progress = parseInt(data.loaded / data.total * 100, 10);
                $('#bar').css('width', progress + '%');
            }
        }).prop('disabled', !$.support.fileInput)
            .parent().addClass($.support.fileInput ? undefined : 'disabled');
    });

    function markerFileCopyUploaded(strFileName) {
        var result = $.ajax({
            url: "ajax.php?chrAction=MUF&idProject=<? echo $_GET['idProject']; ?>&strFileName=" + strFileName
        }).always(function() {
            markersLoad();
        });
    }
    
    function markerDelete(idMarker) {
        var blnDelete = confirm('<? echo $_SESSION['strMarkersConfirmDelete']; ?>');
        if (! blnDelete) return;
		$('#' + idMarker).fadeOut(100, function(){
			$('#' + idMarker).remove();
		});
        var result = $.ajax({
            url: "ajax.php?chrAction=MD&idMarker=" + idMarker
        }).done(function() {

        });
    }
    
    function markersLoad() {
		document.getElementById('strSearch').focus();
        document.getElementById('markersContainer').innerHTML = '<div style="width:100%;text-align:center"><img src="img/loading.gif"></div>';
        var strMarkers;
        var result = $.ajax({
            url: "ajax.php?chrAction=MS&idProject=<? echo $_GET['idProject']; ?>"
        }).always(function() {
            var response 	= result.responseText;
            var arrResult 	= JSON.parse(response);
            strMarkers = '';
            strMarkers += '' +
            '<div class="marker" onClick="document.getElementById(\'fuMarker\').click();" style="position:relative;margin-top:10px;width:50px;">' +
                'Upload' +
                '<br><i class="icon-upload"></i>' +
                '<div id="ContainerBar" class="progress progress-striped" style="width:100%;display:none">' +
                  '<div id="bar" class="bar"></div>' +
                '</div>' +
            '</div>';
			document.getElementById('markersContainer').innerHTML = strMarkers;
            for (var i=0;i<arrResult.length;i++) {
                strMarkers = '' +
                '<div id="' + arrResult[i]['idMarker'] + '" class="marker">' +
                    '<img src="' + arrResult[i]['strMarkerFullPath'] + '" class="marker" title="<? echo $_SESSION['strMarkerTip']; ?>" onClick="markerSelect(' + arrResult[i]['idMarker'] + ', this, false);"/>' +
                    (arrResult[i]['idProject'] == <? echo $_GET['idProject']; ?> ? '<div style="position:absolute;text-align:right;width:100%;top:3px;cursor:pointer"><span class="btn btn-danger" style="padding:2px;" onClick="markerDelete(' + arrResult[i]['idMarker'] + ')"><i class="icon-trash icon-white" data-rel="tooltip" title="<? echo $_SESSION['strMarkerDeleteMarker']; ?>"></i></span></div>' : '') +
                '</div>';
				document.getElementById('markersContainer').innerHTML += strMarkers;
            }
        });
    }
	
	function markerSelect(idMarker, imgMarker, blnFromGoogleImages) {
		<? if ($_GET['s'] == 'admManageForms') { ?>
		parent.document.getElementById('imgForm').src = imgMarker.src;
		if (idMarker > 0) {
	        $.ajax({
				url: "ajax.php?chrAction=FUP&idForm=<? echo $_GET['idForm']; ?>&strField=idMarker&strValue=" + idMarker
			}).always(function() {
				parent.$.fancybox.close();
			});
		} else {
	        $.ajax({
				url: "ajax.php?chrAction=FUMG&strFileName=" + encodeURIComponent(imgMarker.src) + "&idProject=<? echo $arrProject['idProject']; ?>&idMarker=" + idMarker
			}).always(function() {
				parent.$.fancybox.close();
			});
		}
		<? } else if ($_GET['s'] == 'home') { ?>
			var result = $.ajax({
				url: "ajax.php?chrAction=FUMG&strFileName=" + encodeURIComponent(imgMarker.src) + "&idUserFilter=<? echo $_GET['idUserFilter']; ?>&idFormRecord=<? echo $_GET['idFormRecord']; ?>&idProject=<? echo $arrProject['idProject']; ?>&idMarker=" + idMarker
			}).always(function() {
				if (blnFromGoogleImages) {
					imgMarker.src = result.responseText;
				}
				<? if ($_GET['idUserFilter']) { ?> // User Filter Standard Maker Panel Called
					parent.document.getElementById('imgUserFilterMarker').src = imgMarker.src;
				<? } ?>
				<? if ($_GET['idFormRecord']) { ?> // Change Selected Marker
					parent.recordMarkerChange(<?=$_GET['idFormRecord']?>, imgMarker.src);
				<? } else { ?>
				parent.document.getElementById('strNewValue').value = imgMarker.src;
				parent.mapSelectedRecordsAction('CI');
				<? } ?>
				parent.$.fancybox.close();
			});
		<? } ?>
	}

	markersLoad();
</script>