<?
	include_once '../engine/geodesign.php';
	$geodesign = new Geodesign();
	include_once '../engine/api.php';
	$api = new Api();
?>
<? $strings->changePageTitle($_SESSION['strHeaderMenuToolsGeodesignHub']); ?>
<style>
	html{overflow-y: hidden;}
	#mapcanvas:focus {outline: none;}
	.dropdown-menu a {padding:0px;}
	.dropdown-menu > li > a  {padding:3px;}
	.menuItem {cursor:pointer;margin:0px;padding:3px;text-align:left}
	.map-status-bar {margin-bottom:7px;color:#000000;font-weight:bold;font-size:12px;background-color:#ffffff;border:solid 1px #000000;padding:3px;}
</style>
<div class="sessionTitle">
	<img src="../img/geodesign-hub.png" style="height:24px"> 
    <a href="<?=$geodesign->strSiteURL?>" target="_blank"><? echo $_SESSION['strHeaderMenuToolsGeodesignHub']; ?></a> | 
    <a href="<?=$geodesign->strSiteGetTokenURL?>" target="_blank"><?=$_SESSION['strToolGeodesignGetToken']?></a>
    </div>
<div style="width:99%;display:table-row;white-space:nowrap;">
	<input type="text" id="strAPIToken" style="width:97%;display:table-cell;vertical-align:middle;margin:0px;" placeholder="<? echo $_SESSION['strToolGeodesignAPIAccessToken']; ?>..." value="<?=$_COOKIE['strAPIToken'];?>">
	<div id="btnGeodesignLoadUserProjects" class="btn btn-success" style="min-width:100px;width:2%;display:table-cell" onClick="geodesingLoadUserProjects();"><?=$_SESSION['strToolGeodesignLoadData']?></div>    
</div>
<select id="cmbGeodesignUserProjects" onChange="geodesingLoadProjectMembers();" style="width:98%;display:none;margin-top:10px"></select>
<table id="tblGeodesignProjectData" style="width:100%;height:400px;margin-top:5px"><tr>
<td style="width:20%;vertical-align:text-top;white-space:nowrap;">
	<select id="cmbGeodesignProjectMembers" style="width:170px;margin:0px" onChange="geodesignLoadMemberDiagrams();"></select>
    <div id="btnExport" class="btn-group" style="position:relative;width:40px;">
        <a class="btn btn-info dropdown-toggle" data-toggle="dropdown" href="#"><img src="../img/save.png" style="height:16px"> <i class="caret"></i></a>
        <ul class="dropdown-menu">
            <li><a class="menuItem" onClick="geodesignDiagramsExport('SHP');"><img src="../img/filetypes/shp.png" style="height:16px" align="absmiddle"> ESRI ArcGIS (SHP)</a></li>
            <!--<li><a class="menuItem" onClick="geodesignDiagramsExport('DXF');"><img src="../img/filetypes/dxf.png" style="height:16px" align="absmiddle"> CAD (DXF)</a></li>-->
            <li><a class="menuItem" onClick="geodesignDiagramsExport('KML');"><img src="../img/filetypes/kml.png" style="height:16px" align="absmiddle"> Google Earth (KML)</a></li>
            <li><a class="menuItem" onClick="geodesignDiagramsExport('LKML');"><img src="../img/filetypes/kml.png" style="height:16px" align="absmiddle"> Live KML (KML)</a></li>
            <li><a class="menuItem" onClick="API('wfs');"><img src="../img/wfs.png" style="height:16px" align="absmiddle"> WFS Service</a></li>
            <li><a class="menuItem" onClick="API('csv');"><img src="../img/filetypes/csv.png" style="height:16px" align="absmiddle"> CSV for Grasshopper</a></li>
        </ul>
    </div><br>
	<!--<div style="font-weight:bold"><?=$_SESSION['strToolGeodesignProjectDiagrams']?>:</div>-->
	<select id="cmbGeodesignProjectDiagrams" style="margin-top:5px" multiple onChange="geodesignLoadProjectDiagram();"></select>
</td>
<td style="width:80%;">
	<div id="mapcanvas" style="width:100%;height:50px;"></div>
    <div id="divMapStatusBar" class="rounded map-status-bar"></div>
</td>
</tr></table>
<script>
	var map, poly;
	function mapInitialize() {
		var mapOptions = {
			zoom: <? echo is_numeric($_COOKIE['intZoom']) ? $_COOKIE['intZoom'] : 7; ?>, 
			mapTypeId: google.maps.MapTypeId.<? echo ($_COOKIE['strMapTypeId'] ? $_COOKIE['strMapTypeId'] : $strings->strGoogleMapsDefaultTypeMap); ?>, 
			center: new google.maps.LatLng(-20.387836742693,-43.604736328125)
		}
		map = new google.maps.Map(document.getElementById("mapcanvas"), mapOptions);
		map.controls[google.maps.ControlPosition.BOTTOM_LEFT].push(document.getElementById('divMapStatusBar'));
		mapResize();
	}
	
	function mapResize(event) {
		document.getElementById("mapcanvas").style.height = ($(window).height() - 240) + "px";
		document.getElementById("tblGeodesignProjectData").style.height = ($(window).height() - 240) + "px";
		document.getElementById("cmbGeodesignProjectDiagrams").style.height = ($(window).height() - 265) + "px";
	}
	
	$(window).resize(function() {
		mapResize();
	});
	
	function geodesingLoadUserProjects() {
		var strAPIToken = document.getElementById("strAPIToken").value;
		if (! strAPIToken) {
			document.getElementById("strAPIToken").focus();
			return;
		}
		$('#btnGeodesignLoadUserProjects').button('loading');
		document.getElementById("cmbGeodesignUserProjects").style.display = 'none';
		var cmbGeodesignUserProjects = document.getElementById('cmbGeodesignUserProjects');
		// Clear Projects List
	    for (var i=cmbGeodesignUserProjects.options.length-1;i>=0;i--) { cmbGeodesignUserProjects.remove(i); }
		var opt = document.createElement('option');
		opt.value = "";
		opt.text = "<?=$_SESSION['strToolGeodesignProject']?>...";
		cmbGeodesignUserProjects.add(opt);
		var result = $.ajax({
			url: '../ajax.php?chrAction=SGUPL' + 
				'&strAPIToken=' + strAPIToken,
			complete:function() {
				$('#btnGeodesignLoadUserProjects').button('reset');
				var response 	= result.responseText;
				var arrResult 	= JSON.parse(response);
	            for (var i=0;i<Object.keys(arrResult).length;i++) {
					var opt = document.createElement('option');
					opt.value = arrResult[i]['id'];
					opt.text = arrResult[i]['projecttitle'];
					cmbGeodesignUserProjects.add(opt);
				}
				document.getElementById("cmbGeodesignUserProjects").style.display = 'block';
				$("#cmbGeodesignUserProjects:first").focus();
			}
		});
	}
	
	function geodesingLoadProjectMembers(){
		var strAPIToken = document.getElementById("strAPIToken").value;
		var idProject = document.getElementById("cmbGeodesignUserProjects").value;
		if (! idProject) return;
		showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 1);
		var cmbGeodesignProjectMembers = document.getElementById('cmbGeodesignProjectMembers');
		// Reset Project Members List
	    for (var i=cmbGeodesignProjectMembers.options.length-1;i>=0;i--) { cmbGeodesignProjectMembers.remove(i); }
		var opt = document.createElement('option');
		opt.value = "";
		opt.text = "-- <?=$_SESSION['strToolGeodesignProjectAllMembers']?> --";
		cmbGeodesignProjectMembers.add(opt);
		var result = $.ajax({
			url: '../ajax.php?chrAction=SGPM' + 
				'&idProject=' + idProject + 
				'&strAPIToken=' + strAPIToken,
			complete:function() {
				var response 	= result.responseText;
				var arrResult 	= JSON.parse(response);
				var arrMembers = arrResult['arrMembers'];
	            for (var i=0;i<Object.keys(arrMembers).length;i++) {
					var opt = document.createElement('option');
					opt.value = arrMembers[i]['username'];
					opt.text = arrMembers[i]['username'];
					cmbGeodesignProjectMembers.add(opt);
				}
				geodesignLoadMemberDiagrams();
				showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 2);
			}
		});
	}
	
	function geodesignLoadMemberDiagrams(){
		var strAPIToken = document.getElementById("strAPIToken").value;
		var idProject = document.getElementById("cmbGeodesignUserProjects").value;
		document.getElementById("btnExport").style.display = idProject ? "inline-block" : "none";
		if (! idProject) return;
		var idMember = document.getElementById("cmbGeodesignProjectMembers").value;
		showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 1);
		// Reset Project Diagrams List
		var cmbGeodesignProjectDiagrams = document.getElementById('cmbGeodesignProjectDiagrams');
	    for (var i=cmbGeodesignProjectDiagrams.options.length-1;i>=0;i--) { cmbGeodesignProjectDiagrams.remove(i); }
		var result = $.ajax({
			url: '../ajax.php?chrAction=SGPMD' + 
				'&idProject=' + idProject + 
				'&idMember=' + idMember + 
				'&strAPIToken=' + strAPIToken,
			complete:function() {
				var response 	= result.responseText;
				var arrResult 	= JSON.parse(response);
				var arrDiagrams = arrResult['arrDiagrams'];
	            for (var i=0;i<arrDiagrams.length;i++) {
					var opt = document.createElement('option');
					opt.value = arrDiagrams[i]['id'];
					opt.text = '[' + arrDiagrams[i]['sysname'] + '] ' + arrDiagrams[i]['worlddescription'];
					cmbGeodesignProjectDiagrams.add(opt);
				}
				showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 2);
			}
		});
	}
	
	function geodesignLoadProjectDiagram(){
		var strAPIToken = document.getElementById("strAPIToken").value;
		var idProject = document.getElementById("cmbGeodesignUserProjects").value;
		var idDiagram = document.getElementById("cmbGeodesignProjectDiagrams").value;
		var divMapStatusBar = document.getElementById("divMapStatusBar");
		if (! idDiagram) return;
		if (poly) poly.setMap(null);
		divMapStatusBar.innerHTML = '';
		showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 1);
		var result = $.ajax({
			url: '../ajax.php?chrAction=SGPD' + 
				'&idProject=' + idProject + 
				'&idDiagram=' + idDiagram + 
				'&strAPIToken=' + strAPIToken,
			complete:function() {
				var response 	= result.responseText;
				var arrResult 	= JSON.parse(response);
				divMapStatusBar.innerHTML = arrResult['areatype'] + ' | ' + arrResult['author'];
				var arrPath = new google.maps.MVCArray();
				for (i=0;i<arrResult['arrCoordinates'].length;i++) {
					arrPath.push(new google.maps.LatLng(arrResult['arrCoordinates'][i]['dblLatitude'], arrResult['arrCoordinates'][i]['dblLongitude']));
				}
				var pOptions = {fillColor: arrResult['color'], fillOpacity: (arrResult['areatype'] == 'project' ? 0.6 : 0), strokeColor: '#ff0000', strokeOpacity: 0.3, strokeWeight: 4, visible: true, map: map, zIndex: 1, path: arrPath};				
				if (arrResult['intShapeType'] == 2) {
					poly = new google.maps.Polyline(pOptions);
				} else {
					poly = new google.maps.Polygon(pOptions);
				}
				var bounds = mapPolygonGetBounds(poly);
				map.fitBounds(bounds);
				showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 2);
			}
		});
	}
	
	function mapPolygonGetBounds(polygon) {
	    var bounds = new google.maps.LatLngBounds()
    	polygon.getPath().forEach(function(element,index){bounds.extend(element)})
	    return bounds;
	}
	
	function geodesignDiagramsExport(strExt) {
		var cmbGeodesignProjectDiagrams = document.getElementById("cmbGeodesignProjectDiagrams");
		var cmbGeodesignUserProjects = document.getElementById("cmbGeodesignUserProjects");
		if (! cmbGeodesignUserProjects.value) return;
		showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 1);
		var result = $.ajax({
			url: '../ajax.php?chrAction=SGPDE' + 
				'&idProject=' + document.getElementById("cmbGeodesignUserProjects").value + 
				'&strProjectName=' + cmbGeodesignUserProjects.options[cmbGeodesignUserProjects.selectedIndex].text +
				'&strAPIToken=' + document.getElementById("strAPIToken").value + 
				'&strExt=' + strExt,
			complete:function() {
				showInfoAlert("<?=$_SESSION['strGlobalProcessing']?>...", 2);
				var response 	= result.responseText;
				var retorno 	= JSON.parse(response);
				if (retorno['strFilePath']) {
					window.location='../output.php?strName=' + retorno['strFilePath'].toLowerCase() + '&strFileName=' + retorno['strFilePathTMP'];
				}
			}
		});
	}
	
	function API(strExtension){
		var strAPIToken = document.getElementById("strAPIToken").value;
		if (! strAPIToken) {
			document.getElementById("strAPIToken").focus();
			return;
		}
		window.open('<?=$api->strURLAPI?>action=geodesign-' + strExtension + (strExtension == 'csv' ? '-diagrams' : '') + '&token=' + strAPIToken + (strExtension == 'csv' ? '&output=csv&idproject=' + document.getElementById("cmbGeodesignUserProjects").value : ''));
	}
	
	$(document).ready(function () {
		mapInitialize();
		geodesingLoadUserProjects();
	});
</script>