<? 
	session_start();
	// Initializing Engine Classes
	include_once 'engine/strings.php';
	$strings = new Strings();		
	include_once 'engine/database.php';
	$database = new Database();	
	include_once 'engine/formrecord.php';
	$formrecord = new Formrecord($database);

	$arrChart = $formrecord->arrFormRecordTimeSeriresChart($_GET['idFormRecordField']);
	$strData = json_encode($arrChart);
?>
<script src="js/jquery-1.11.1.js"></script>
<script src="js/jquery-ui.js"></script>
<script src="js/charts/Lib/js/knockout-3.0.0.js"></script>
<script src="js/charts/Lib/js/globalize.min.js"></script>
<script src="js/charts/Lib/js/dx.chartjs.js"></script>
<style>
	.chart {width:100%;height:100%;}
	::-webkit-clear-button{display: none; -webkit-appearance: none; }
</style>
<div class="chart" id="chart"></div>
<script>
var arrDataSource = new Array();
var intTotal = 0;

var arrData = JSON.parse('<?=$strData;?>');
if (! arrData['arrValues']) {
	arrData['arrValues'] = [];
}
// Series Names
var arrSeries = new Array();
for (var i=1;i<arrData['arrLabels'].length;i++)	{
	arrSeries.push({"valueField" : "Y" + i, "name" : arrData['arrLabels'][i]});
}
// Series Values
for (var i=0;i<arrData['arrValues'].length;i++)	{
	var arrKeys = {};
	arrKeys['X'] = arrData['arrValues'][i][0];
	for (var j=1;j<arrData['arrValues'][i].length;j++)	{
		arrKeys['Y' + j] = parseInt(arrData['arrValues'][i][j]);
		intTotal++;
	}
	arrDataSource.push(arrKeys);
}
arrData['strTitle'] += ' (' + intTotal + ')';
$("#chart").dxChart({
	dataSource: arrDataSource,
	commonSeriesSettings: {
		color: 'forestgreen',
		argumentField: "X"
	},
	series: arrSeries,
	argumentAxis:{
		grid:{
			visible: true
		}
	},
	tooltip:{
		enabled: true
	},
	title: {
		text: arrData['strTitle'],
		font: { color:'#000000', opacity: 1, weight: 700, size: 14 }
	},
	legend: {
		verticalAlignment: "bottom",
		horizontalAlignment: "center",
		visible: true
	},
	commonPaneSettings: {
		border:{
			visible: true,
			right: false
		}       
	}
});
</script>