<?php
  // Documentation Page: http://www.cemaden.gov.br/mapainterativo/#
  // Example: http://150.163.255.240/CEMADEN/resources/parceiros/SP/1
  include_once '../engine/strings.php';
  $strings = new Strings();
  header('Content-type: text/xml');
  set_time_limit(120);
  $arrResult = array();
  $_GET['uf'] = $_GET['uf'] ? $_GET['uf'] : 'RJ';
  $strUrl = 'http://150.163.255.240/CEMADEN/resources/parceiros/' . $_GET['uf'] . '/1';
  $data = $strings->processUrl($strUrl);
  $json = $strings->objectify('json', $data);
  foreach($json->{"cemaden"} as $entry) {
	if (($_GET['limit']) && (count($arrResult['record']) >= $_GET['limit'])) { break; }
	$date = date("Y-m-d H:i:s", strtotime($entry->{'dataHora'}));
	$entry->{'id'} = $entry->{'codestacao'};
	$entry->{'date'} = $date;
	$entry->{'coordinates'} = $entry->{'longitude'} . ',' . $entry->{'latitude'};
	$arrResult['record'][] = $entry;
  }
  echo utf8_decode($strings->strArrayToXML2($arrResult));
?>