<?php
	// Documentation Page: https://developers.google.com/+/web/api/rest/latest/activities/search | https://developers.google.com/+/web/api/rest/latest/activities
	// Example: https://www.googleapis.com/plus/v1/activities?query=copacabana&key=AIzaSyD-a9IF8KKYgoC3cpgS-Al7hLQDbugrDcw
	$accountAPIKey = "AIzaSyAbUyx5D1yREUU8Ztkg4CJatQ9lj12kn3s";	
	include_once '../engine/strings.php';
	$strings = new Strings();
	header('Content-type: text/xml');
	set_time_limit(120);
	$arrResult = array();
	$strUrl = 'https://www.googleapis.com/plus/v1/activities?fields=etag%2Cid%2Citems%2Ckind%2CnextLink%2CnextPageToken%2CselfLink%2Ctitle%2Cupdated&key=' . $accountAPIKey . '&' . $_SERVER["QUERY_STRING"];
	$data = $strings->processUrl($strUrl);
	$json = $strings->objectify('json', $data);
	foreach($json->{"items"} as $entry) {
		// Files
		$arrFiles = array();
		foreach($entry->{'object'}->{'attachments'} as $media) {
		  $arrFiles[] = $media->{'image'}->{'url'};
		}
		/*
		$entry->{'id'} = $entry->{'id'};
		$entry->{'date'} = date("Y-m-d H:i:s", strtotime($entry->{'published'}));
		$entry->{'coordinates'} = $entry->{'location'}->{'position'}->{'longitude'} . ',' . $entry->{'location'}->{'position'}->{'latitude'};
		$entry->{'files'} = implode(';', $arrFiles);
		$arrResult['record'][] = $entry;
		*/
		$arrRecord = array();
		$arrRecord['id'] = $entry->{'id'};
		$arrRecord['date'] = date("Y-m-d H:i:s", strtotime($entry->{'published'}));
		$arrRecord['coordinates'] = $entry->{'location'}->{'position'}->{'longitude'} . ',' . $entry->{'location'}->{'position'}->{'latitude'};
		$arrRecord['files'] = implode(';', $arrFiles);
		$arrRecord['actor'][0]['id'] = $entry->{'actor'}->{'id'};
		$arrRecord['actor'][0]['displayName'] = $entry->{'actor'}->{'displayName'};
		$arrRecord['actor'][0]['url'] = $entry->{'actor'}->{'url'};
		$arrRecord['actor'][0]['image'] = $entry->{'actor'}->{'image'}->{'url'};
		$arrRecord['title'] = $entry->{'title'};
		$arrRecord['content'] = $entry->{'object'}->{'content'};
		$arrRecord['url'] = $entry->{'url'};
		$arrRecord['replies_count'] = $entry->{'object'}->{'replies'}->{'totalItems'};
		$arrRecord['plusoners_count'] = $entry->{'object'}->{'plusoners'}->{'totalItems'};
		$arrRecord['resharers_count'] = $entry->{'object'}->{'resharers'}->{'totalItems'};
		$arrResult['record'][] = $arrRecord;
	}
	echo utf8_decode($strings->strArrayToXML2($arrResult));
?>