<?php
  // Documentation Page: https://www.tumblr.com/docs/en/api/v2
  // API Console: https://api.tumblr.com/console/calls/user/info
  $strAPIKey = "jqm1Y4w7hq54vpYAO4FlUoViOscjssdIQjwbE25Bi8exnCNbBh";	
  include_once '../engine/strings.php';
  $strings = new Strings();
  header('Content-type: text/xml');
  set_time_limit(120);
  $arrResult = array();
  $strUrl = 'https://api.tumblr.com/v2/tagged?api_key=' . $strAPIKey . '&' . $_SERVER["QUERY_STRING"];
  $data = $strings->processUrl($strUrl);
  $json = $strings->objectify('json', $data);
  foreach($json->{"response"} as $entry) {
	// Files
	$arrFiles = array();
	foreach($entry->{'photos'} as $media) {
	  $arrFiles[] = $media->{'original_size'}->{'url'};
	}
	/*
	$entry->{'id'} = $entry->{'id'};
	$entry->{'date'} = date("Y-m-d H:i:s", strtotime($entry->{'timestamp'}));
	$entry->{'files'} = implode(';', $arrFiles);
	$arrResult['record'][] = $entry;
	*/
	$arrRecord = array();
	$arrRecord['id'] = $entry->{'id'};
	$arrRecord['date'] = date("Y-m-d H:i:s", $entry->{'timestamp'});
	$arrRecord['files'] = implode(';', $arrFiles);
	$arrRecord['blog_name'] = $entry->{'blog_name'};
	$arrRecord['post_url'] = $entry->{'post_url'};
	$arrRecord['slug'] = $entry->{'slug'};
	$arrRecord['type'] = $entry->{'type'};
	$arrRecord['format'] = $entry->{'format'};
	$arrRecord['summary'] = $entry->{'summary'};
	$arrRecord['note_count'] = $entry->{'note_count'};
	$arrRecord['caption'] = $entry->{'caption'};
	$arrResult['record'][] = $arrRecord;
  }
  echo utf8_decode($strings->strArrayToXML2($arrResult));
?>