<?php
	// Documentation: https://developers.google.com/youtube/v3/docs/search/list?hl=pt-br
	// Example: https://www.googleapis.com/youtube/v3/search?&part=snippet&q=botafogo&location=37.42307%2C-122.08427&locationRadius=100km&type=video&key=AIzaSyBUH0Z9V-etodZQ4NJoKH5ukjYntXKlMZg
	$accountAPIKey = "AIzaSyBUH0Z9V-etodZQ4NJoKH5ukjYntXKlMZg";
	include_once '../engine/strings.php';
	$strings = new Strings();
	header('Content-type: text/xml');
	set_time_limit(120);
	$arrResult = array();		
	$strUrl = 'https://www.googleapis.com/youtube/v3/search?part=snippet&type=video&key=' . $accountAPIKey . '&' . $_SERVER["QUERY_STRING"];
	$data = $strings->processUrl($strUrl);
	$json = $strings->objectify('json', $data);
	// Loop for each result
	if ($json->{"items"}) {
	  foreach($json->{"items"} as $entry) {
		$entry->{'id'} = $entry->{"snippet"}->{'channelId'} . '-' . $entry->{"snippet"}->{'publishedAt'};
		$entry->{'date'} = date("Y-m-d H:i:s", strtotime($entry->{"snippet"}->{'publishedAt'}));
		$arrCoordinates = explode(' ', $entry->{'georss$where'}->{'gml$Point'}->{'gml$pos'}->{'$t'});
		$entry->{'coordinates'} = $arrCoordinates[0] . ',' . $arrCoordinates[1];
		$entry->{'files'} = $entry->{'snippet'}->{'thumbnails'}->{'high'}->{'url'};
		$arrResult['record'][] = $entry;
	  }
	}
	echo utf8_decode($strings->strArrayToXML2($arrResult));
?>