<?
	session_start();
	// Initializing Engine Classes
	include_once 'engine/database.php';
	$database = new Database();
	include_once 'engine/strings.php';
	$strings = new Strings();
	include_once 'engine/project.php';
	$project = new Project($database);
	include_once 'engine/form.php';
	$form = new Form($database);

	$arrForm = $form->selectForms(0, $_GET['idForm']);
	$arrForm = $arrForm[0];
	$arrFormFields = $form->selectFormFields($arrForm['idForm']);
	$arrProject = $project->selectProjects($arrForm['idProject']);
	$arrProject = $arrProject[0];
	// Loading strings according to selected language
	$_SESSION['strSiteLanguage'] = ($_GET['language'] ? $_GET['language'] : $arrProject['strLanguageCode']);
	$strings->loadLanguage($_SESSION['strSiteLanguage']);
?>
<!DOCTYPE html>
<html lang="pt-BR">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="viewport" content="height=device-height,width=device-width,initial-scale=1,user-scalable=yes" />
<title><? echo $arrProject['strName'] . '  ' . $_SESSION['strRecordEditPrintFormStructure'] . ' ' . $arrForm['strName']; ?></title>
    <link rel="shortcut icon" href="<? echo $arrProject['strLogoFileFullPath']; ?>">
    <link media="all" href="css/bootstrap.css" rel="stylesheet">
	<link media="all" href="css/bootstrap-<? echo $arrProject['strThemeName']; ?>.css" rel="stylesheet">
	<link media="all" href="css/bootstrap-responsive.css" rel="stylesheet">
	<link media="all" href="css/main.css" rel="stylesheet">
	<link media="all" href="css/charisma.css" rel="stylesheet">
    <script src="js/jquery-1.11.1.js"></script>
	<script src="js/jquery-ui.js"></script>
	<script src="js/bootstrap-button.js"></script>
	<script src="js/main.js"></script>
</head>
<body style="padding:10px;margin:0px;overflow-x:hidden">
<? if (! count($arrForm)) { ?>
	<? echo $_SESSION['strGlobalUnknownRecord']; ?>
<? } else if ((! $arrProject['blnAllowAllView']) && (! ($_SESSION['idUser'] > 0))) { ?>
	<? include 'login.inc'; ?>
<? } else { ?>
	<div style="width:99%;background-color:#000;color:#FFFFFF;border:solid 1px #000000;font-weight:bold;padding:5px;margin-bottom:5px;" class="rounded">
    	<img src="<?=$arrForm['strMarkerFullPath'];?>" style="height:24px;"> 
		<? echo $arrProject['strName'] . '  ' . $arrForm['strName']; ?>
	</div>
    <!-- Header Information -->
    <table width="100%"><tr>
        <td width="70%">
          <!-- Name --> 
          <label class="control-label" style="font-weight:bold"><?=$_SESSION['strFormPrintName']?>:</label>
          <input type="text" class="fullwith">
        </td>
        <td width="30%">
          <!-- Data & Time --> 
          <label class="control-label" style="font-weight:bold"><?=$_SESSION['strFormPrintDateTime']?>:</label>
          <input type="text" class="fullwith">
        </td>
    </tr>
    </table>
    <!-- End Header Information -->
	<?
	  foreach ($arrFormFields as $idLine => $arrFormField) {
		$strFieldName = $arrFormField['strName'] . ' [' . $_SESSION['strFormFieldType_' . $arrFormField['idFormFieldType']] . ']';
		$intLevel = 0;
		$arrFieldNamePrev = explode(':', $arrFormFields[$idLine-1]['strName']);
		$arrFieldNameCurr = explode(':', $arrFormFields[$idLine]['strName']);
		if (strpos($strFieldName, ':')) {
			$intLevel = 1;
			$strFieldName = $arrFieldNameCurr[0] . '<br><span style="margin-left:' . $strings->intFieldLevelIndentPx . 'px;">' . $arrFieldNameCurr[1] . '</span>';
		}
		if ($arrFieldNamePrev[0] == $arrFieldNameCurr[0]) {
			$intLevel = 1;
			$strFieldName = '<span style="margin-left:' . $strings->intFieldLevelIndentPx . 'px;">' . $arrFieldNameCurr[1] . '</span>';
		}			
		echo '<label class="control-label" style="font-weight:bold">' . $strFieldName . ($arrFormField['strTip'][0] == '=' ? ' [' . $arrFormField['strTip'] . ']' : '') . ': </label>';
		if ($arrFormField['strTip']) {
			echo '<div><i>' . $arrFormField['strTip'] . '</i></div>'; 
		}
		echo '<div ' . ($intLevel > 0 ? 'style="padding-left:' . ($intLevel*$strings->intFieldLevelIndentPx) . 'px;"' : '') . '>';
		if (($arrFormField['idFormFieldType'] == 3) || ($arrFormField['idFormFieldType'] == 4)) {
			echo '<div style="padding-left:20px;">';
			$arrFormFieldAlternatives = $form->selectFieldAlternatives($arrFormField['idFormField']);
			$blnHasOther = false;
			foreach ($arrFormFieldAlternatives as $i => $arrFormFieldAlternative) {
				if (
					strtoupper($_SESSION['strGlobalOther']) == strtoupper($arrFormFieldAlternative['strAlternative']) ||
					strtoupper($_SESSION['strGlobalOthers']) == strtoupper($arrFormFieldAlternative['strAlternative'])
				)  { 
					$blnHasOther = true;
				} else {
					echo '<input type="' . ($arrFormField['idFormFieldType'] == 3 ? 'radio' : 'checkbox') . '"> ' . $arrFormFieldAlternative['strAlternative'] . ($i < count($arrFormFieldAlternatives) - 1 ? ' | ' : '');
				}
			}
			if ($blnHasOther) {
				echo '<input type="text" class="fullwith" placeholder="' . $_SESSION['strGlobalOther'] . '...">';
			}
			echo '</div>';
		} else {
			echo '<input type="text" class="fullwith">';
		}
		echo '</div>';
	  }
	?>
<? } ?>
</body>
</html>