<?
	ini_set('display_errors', 0); 
	session_start();
	if (! $_GET['dblLatitude']) $_GET['dblLatitude'] = 0;
	if (! $_GET['dblLongitude']) $_GET['dblLongitude'] = 0;

	if ($_POST['blnSave']) {
		$_POST['dblLat'] = number_format($_POST['dblLat'], 7);
		$_POST['dblLng'] = number_format($_POST['dblLng'], 7);
		echo '
		<script>
			parent.document.getElementById("dblLatitude").value = "' . $_POST['dblLat'] . '";
			parent.document.getElementById("dblLongitude").value = "' . $_POST['dblLng'] . '";
			if (parent.document.getElementById("strMyLocation")) {
				parent.document.getElementById("strMyLocation").innerHTML = "' . $_POST['dblLat'] . ':' . $_POST['dblLng'] . '";
				parent.userUpdate();
			}
			if (parent.document.getElementById("strAddress")) {
				parent.document.getElementById("strAddress").value = "' . $_POST['txtSearchBox'] . '";
			}
			if (parent.document.getElementById("strLanguageCode")) {
				parent.document.getElementById("strLanguageCode").value = "' . $_POST['strLanguageCode'] . '";
			}
			parent.$.fancybox.close();
		</script>';
	}
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
	<link href="css/bootstrap-cerulean.css" rel="stylesheet">
	<link href="css/main.css" rel="stylesheet">
    <style>
		html, body, form{ height: 100%;  margin: 0; padding: 0; }
		#mapcanvas { height: 100%; }
		#panel { position: absolute; top: 5px; left: 50%; margin-left: -180px; z-index: 5;  padding: 5px; /*background-color: #fff;*/ /*border: 1px solid #999;*/}
    </style>
    <script src="https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places"></script>
    <script>
		var marker = null;
		var geocoder;
		function initialize() {
			geocoder = new google.maps.Geocoder();
			var ptCurrentPoint = new google.maps.LatLng(<? echo $_GET['dblLatitude']; ?>, <? echo $_GET['dblLongitude']; ?>);
			var map = new google.maps.Map(document.getElementById('mapcanvas'), {
				mapTypeId: google.maps.MapTypeId.ROADMAP,
				zoom: 15,
				center: ptCurrentPoint
			});
			var icon = {url: "img/marker.png",size: new google.maps.Size(32, 32),origin: new google.maps.Point(0, 0)};
			marker = new google.maps.Marker({map: map, title: '<? echo $_GET['strAddress']; ?>', draggable: true, position: ptCurrentPoint, icon:icon});

			var input = /** @type {HTMLInputElement} */(document.getElementById('txtSearchBox'));
			var searchBox = new google.maps.places.SearchBox(input);
			google.maps.event.addListener(searchBox, 'places_changed', function() {
				var places = searchBox.getPlaces();
				if (marker) {
					marker.setMap(null);
				}
				if ((!places) || (places.length == 0)) return;
				var place = places[0];
				var image = {
					url: place.icon,
					size: new google.maps.Size(71, 71),
					origin: new google.maps.Point(0, 0),
					anchor: new google.maps.Point(17, 34),
					scaledSize: new google.maps.Size(25, 25)
				};

				marker = new google.maps.Marker({
					map: map,
					icon: icon,
					title: place.name,
					draggable: true,
					position: place.geometry.location
				});

				map.panTo(marker.getPosition());
			});
			
			google.maps.event.addListener(map, 'bounds_changed', function() {
				var bounds = map.getBounds();
				searchBox.setBounds(bounds);
			});
			document.getElementById('txtSearchBox').focus();
		}
		google.maps.event.addDomListener(window, 'load', initialize);

		function savePosition() {
			document.getElementById('dblLat').value = marker.getPosition().lat();
			document.getElementById('dblLng').value = marker.getPosition().lng();
			geocoder.geocode({'latLng': marker.getPosition()}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
					for (var i=0;i<results.length;i++) {
						if (results[i].types[0] == "country") {
							document.getElementById('strLanguageCode').value = results[i].address_components[0].short_name.toLowerCase();
							break;
						}
					}
				}
				document.getElementById('blnSave').value = 1;
				document.getElementById('form').submit();
			});
		}		
    </script>
  </head>
  <body>
	<form method="post" name="form" id="form" enctype="multipart/form-data" onKeyPress="if(event.keyCode=='13'){event.preventDefault();}">
    <div id="panel">
		<input id="txtSearchBox" name="txtSearchBox" type="text" class="" style="border:0px;font-family:'Calibri';width:200px;margin-top:7px;" placeholder="<? echo $_SESSION['strGlobalMapTypeLocation']; ?>" value="<? echo utf8_encode($_GET['strAddress']); ?>">
        <input type="hidden" id="dblLat" name="dblLat" value="<? echo $_GET['dblLatitude']; ?>"/>
        <input type="hidden" id="dblLng" name="dblLng"  value="<? echo $_GET['dblLongitude']; ?>"/>
        <input type="hidden" id="strLanguageCode" name="strLanguageCode"  value="<? echo $_GET['strLanguageCode']; ?>"/>
        <input type="hidden" id="blnSave" name="blnSave" value=""/>
        <a class="btn btn-success" href="#" onClick="savePosition();">
            <i class="icon-ok icon-white"></i>
        </a>
        <!--
        <a class="btn btn-danger" href="#" onClick="parent.$.fancybox.close();">
            <i class="icon-remove icon-white"></i>
        </a>
        -->
    </div>
    <div id="mapcanvas"></div>
    </form>
  </body>
</html>