<?	
	$strExt = '';
	if (isset($_FILES["files"])) {
		set_time_limit(150); 
		$arrFiles = $_FILES["files"];
		$strBaseFileName = $strings->generateRandomString(5);
		$blnIsShapeFile = false;
		foreach ($arrFiles['name'] as $i => $strFile) {
			$strExt = explode(".", $strFile);
			$strExt = strtolower(array_pop($strExt));
			if ($strExt == 'shp') {
				$blnIsShapeFile = true;
				$strShpFileName = $strFile;
			}
			$strFileName = $strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.' . $strExt;
			move_uploaded_file($arrFiles["tmp_name"][$i], $strFileName);
		}
		$strFileName = $blnIsShapeFile ? $strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.shp' : $strFileName;
		$strFileNameForm = explode('.', basename($_FILES["files"]['name'][0]));
		$strFileNameForm = $strFileNameForm[0];
		$strExt = $blnIsShapeFile ? 'shp' : $strExt;
		// Call function to fix KML File and set one tag per line
		if ($strExt == 'kml') {
			require_once 'engine/kml.php';
			$kml = new Kml();
			$arrKML = $kml->load($strFileName, false, 10);
			$intNObjects = $arrKML['intNObjects'];
			$strFileInfo = basename($_FILES["files"]['name'][0]) . '  <img src="' . $strings->strImgFilePathByidShapeType(1) . '" style="height:20px;"> ' . $arrKML['intNPoints'] . '  <img src="' . $strings->strImgFilePathByidShapeType(2) . '" style="height:20px;"> ' . $arrKML['intNLines'] . '  <img src="' . $strings->strImgFilePathByidShapeType(3) . '" style="height:20px;"> ' . $arrKML['intNPolygons'] . ' = ' . ($intNObjects) . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if ($strExt == 'csv') {
			// Open CSV file, get header to fill combo
			if($fh = fopen($strFileName, 'r')){
				$strContent = fread($fh, filesize($strFileName));
				fclose($fh);
			}
			$strContent = $strings->chrCSVLineBreak($strContent);
			$arrLines = explode(chr(13), $strContent);
			$chrSeparator = $strings->chrCSVSeparator($arrLines[0]);
			$arrCols = explode($chrSeparator, $arrLines[0]);
			$intNCols = count($arrCols);
			$intNValidLines = 0;
			$strLineJustSemicolon = '';
			for ($i=0;$i<$intNCols-1;$i++) $strLineJustSemicolon .= $chrSeparator;
			for ($i=1;$i<count($arrLines);$i++) {
				if (
					(strpos($arrLines[$i], $chrSeparator) === FALSE) || 
					(strpos($arrLines[$i], $strLineJustSemicolon) === TRUE) ||
					($arrLines[$i] == '')
				) continue;
				$intNValidLines++;
			}
			$intNObjects = $intNValidLines;
			$strFileInfo = basename($_FILES["files"]['name'][0]) . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if (($strExt == 'xls') || ($strExt == 'xlsx')) {
			require_once ('js/excel/Classes/PHPExcel/IOFactory.php');
			$XLS = PHPExcel_IOFactory::load($strFileName);
			// Read Plan 1
			$XLS->setActiveSheetIndex(0);
			$Plan = $XLS->getActiveSheet();
			$intNObjects = 1;
			while($Plan->getCellByColumnAndRow(0, $intNObjects)->getValue() != '') $intNObjects++;
			$intNObjects = $intNObjects - 2; // All but header and last (empty) lines
			// Cols
			$arrCols = array();
			$intCol = 0;
			while($Plan->getCellByColumnAndRow($intCol, 1)->getValue() != '') {
				$arrCols[] = utf8_decode($Plan->getCellByColumnAndRow($intCol, 1)->getValue());
				$intCol++;
			}
			$strFileInfo = basename($_FILES["files"]['name'][0]) . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		} else if ($strExt == 'shp') {
			require 'engine/shapefile/reader/shpParser.php';
			$shp = new shpParser();
			$shp->load($strings->strSiteTmpFileFolder . '/' . $strBaseFileName . '.shp');
			$data = $shp->getShapeData();
			$intNObjects = max($shp->intTotalParts, count($data));
			$shpBB = $shp->headerInfo['boundingBox'];
			// Test if UTM -> Convert to Geographic before continue
			$blnUTM = false;
			$strCoord = explode('.', $shpBB['ymin']);
			$strCoord = $strCoord[0];
			if (strlen($strCoord) >= 4) { $blnUTM = true; }			
			$strFileInfo = $strShpFileName . ' - ' . $intNObjects . ' ' . strtolower($_SESSION['strGlobalRecords']);
		}
	} // End of File Load
?>
<div class="sessionTitle">
	<i class="<? echo $importer->strDefaultIcon; ?>"></i>
	<? echo $_SESSION['strHomeToolsDataImporter']; ?>
	<span class="hidden-phone">
    <? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { echo ' - ' . $strFileInfo; } ?>
    </span>
    <input type="file" name="files[]" id="files[]" onChange="blnIsValidFileExt(this.value);" style="display:none" multiple>
	<? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { ?>
	<a class="btn btn-success" name="btnImport" id="btnImport" data-loading-text="<? echo $_SESSION['strGlobalProcessing']; ?>" style="float:right;position:relative;top:-4px;margin-left:5px;" onClick="importExecute('<? echo $strExt; ?>');"/><i class="icon-play icon-white"></i><span class="hidden-phone"> <? echo $_SESSION['strToolImporterImport']; ?></span></a>
    <? } ?>
	<a class="btn btn-info" name="btnFileLoad" id="btnFileLoad" data-rel="tooltip" title="<? echo $_SESSION['strToolImporterFilesFormatSHPInfo']; ?>" data-loading-text="<? echo $_SESSION['strGlobalWait']; ?>..."  onClick="document.getElementById('files[]').click();" style="float:right;position:relative;top:-4px;"><i class="icon-folder-open icon-white"></i> <? echo $_SESSION['strGlobalLoad']; ?></a>
</div>

<div id="divProgress" class="progress progress-striped progress-success active" style="color:#000000;height:27px;font-weight:bold;display:none">
    <div id="divProgressLabel" style="position:absolute;text-align:center;width:100%;padding-top: 4px;"></div>
    <div id="divProgressBar" class="bar" style="width:0%;line-height:27px;height:27px;color:#000000;text-indent:5px;text-align:center;"></div>
</div>

<? if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx') || ($strExt == 'kml') || ($strExt == 'shp')) { ?>
   <select name="idForm" id="idForm" style="width:100%" onChange="formChange();">
        <option strMarkerFullPath="<? echo $strDefaultMarkerFilePath; ?>" value=""><? echo $_SESSION['strToolImporterErrorSelectForm']; ?></option>
        <?
        if ($arrUser['idUserLevel'] >= 4) {
            echo '<option strMarkerFullPath="' . $strDefaultMarkerFilePath . '" value="N">' . $_SESSION['strToolImporterFormNew'] . '</option>';
            echo '<option strMarkerFullPath="' . $strDefaultMarkerFilePath . '" value="N" selected>' . $strFileNameForm . '</option>';
        }
        $arrForms = $form->selectForms($arrProject['idProject']);
        foreach($arrForms as $arrForm) {
            echo '<option strMarkerFullPath="' .  $arrForm['strMarkerFullPath']. '" strName="' .  $arrForm['strName']. '" value="' .  $arrForm['idForm']. '">' . $arrForm['strName'] . '</option>';
        }
        ?>
    </select>
	<? if ($strExt == 'shp') { ?>
    <select name="idDatumIn" id="idDatumIn" style="width:100%;">
        <option value=""><? echo $_SESSION['strToolConversorDatumOrigin'] . ' (' . $_SESSION['strGlobalOptional'] . ')'; ?></option>
        <?
        $arrDatums = $database->selectDatum();
        foreach ($arrDatums as $arrDatum) {
            echo '<option value="' . $arrDatum['idDatum'] . '" ' . ($_COOKIE['idDatumIn'] == $arrDatum['idDatum'] ? ' selected' : '') . '>' . $arrDatum['strName'] . '</option>';
        }
        ?>
    </select>
    <? } ?>
    <?
	if ($strExt == 'kml') {
		echo $arrKML['strTable'];
	} else if (($strExt == 'shp') && ($blnUTM)) {
		echo '
		<label style="font-weight:bold">' . $_SESSION['strToolImporterUTMZone'] . ':</label>
		<select name="intUTMZone" id="intUTMZone" style="width:50px;">
		';
		for ($i=1;$i<=60;$i++) {
			echo '<option value="' . $i . '" ' . ($_COOKIE['intUTMZone'] == $i ? ' selected' : '') . '>' . $i . '</option>';
		}
		echo '
		</select>
		<select name="chrUTMHemisphere" id="chrUTMHemisphere" style="width:70px">
            <option value="K" ' . ($_COOKIE['chrUTMHemisphere'] == "K" ? ' selected' : '') . '>Sul</option>
            <option value="N" ' . ($_COOKIE['chrUTMHemisphere'] == "N" ? ' selected' : '') . '>Norte</option>
	    </select>
		';
	} else if (($strExt == 'csv') || ($strExt == 'xls') || ($strExt == 'xlsx')) {
		echo '<select name="idLatitude" id="idLatitude" style="width:100%">
			<option value="">' . $_SESSION['strToolImporterSelectLatitude'] . '</option>';
		$i=1;
		foreach($arrCols as $strCol) {
			$blnIsCoordinateField = false;
			if (
				(strpos(strtoupper($strCol), 'LAT') !== FALSE) ||
				(strpos(strtoupper($strCol), 'GEOMETRY') !== FALSE) // Google Fusion Tables
			) {
				$blnIsCoordinateField = true;
			}
			echo '<option value="' . $i . '" ' . ($blnIsCoordinateField ? 'selected' : '') . '>' . $strCol . ' </option>';
			$i++;
		}			
		echo '</select>';
		
		echo '<select name="idLongitude" id="idLongitude" style="width:100%">
			<option value="">' . $_SESSION['strToolImporterSelectLongitude'] . '</option>';
		$i=1;
		foreach($arrCols as $strCol) {
			$blnIsCoordinateField = false;
			if (
				(strpos(strtoupper($strCol), 'LONG') !== FALSE) ||
				(strpos(strtoupper($strCol), 'LNG') !== FALSE) ||
				(strpos(strtoupper($strCol), 'GEOMETRY') !== FALSE) // Google Fusion Tables
			) {
				$blnIsCoordinateField = true;
			}
			echo '<option value="' . $i . '" ' . ($blnIsCoordinateField ? 'selected' : '') . '>' . $strCol . ' </option>';
			$i++;
		}			
		echo '</select>';
		echo '<input id="ckbNoNullCoords" type="checkbox" ' . ($_COOKIE['blnNoNullCoords'] == 1 ? "checked" : "") . '/> <label for="ckbNoNullCoords" style="display:inline-block;">' . $_SESSION['strToolImporterDontImportNoCoordinates'] . '</label><br>';
		// Atached Files
		echo '<label style="font-weight:bold;margin-top:10px;"><a href="javascript:attachmentShowHide(true);"><i class="icon-question-sign"></i> ' . $_SESSION['strRecordEditSessionFilesTitle'] . ' (' . $_SESSION['strGlobalOptional'] . ')</a>:</label>';
		echo '<div id="divAttachment" style="display:none">';
		echo '<select name="idAttachmentFolderName" id="idAttachmentFolderName" style="width:100%">
			<option value="">' . $_SESSION['strToolImporterSelectAtachmentFolder'] . '</option>';
		$i=1;
		foreach($arrCols as $strCol) {
			echo '<option value="' . $i . '" ' . ($_COOKIE['idAttachmentFolderName'] == $i ? ' selected' : '') . '>' . $strCol . ' </option>';
			$i++;
		}			
		echo '</select>';
		echo '<i>' . $_SESSION['strToolImporterSelectAtachmentServerRootFolderNotePermission'] . '</i><br>';
		echo '<input id="strFTPFolderPath" name="strFTPFolderPath" type="text" placeholder="' . $_SESSION['strToolImporterSelectAtachmentServerRootFolder'] . ' Ex.: ftp.viconsaga.com.br/tmp/ANEXOS/" class="fullwith" value="' . ($_COOKIE['strFTPFolderPath'] ? $_COOKIE['strFTPFolderPath'] : "") . '"/><br>';
		echo '<input id="strFTPUser" name="strFTPUser" type="text" placeholder="FTP Server Username" class="fullwith" value="' . ($_COOKIE['strFTPUser'] ? $_COOKIE['strFTPUser'] : "") . '"/><br>';
		echo '
			<div class="input-prepend fullwith">
                <span class="add-on" style="cursor:pointer" onMouseDown="document.getElementById(\'strFTPPassword\').type=\'text\';" onMouseUp="document.getElementById(\'strFTPPassword\').type=\'password\';"><i class="icon-eye-open"></i></span>
                <input id="strFTPPassword" name="strFTPPassword" type="password" placeholder="FTP Server Password" class="fullwith" value="' . ($_COOKIE['strFTPPassword'] ? $_COOKIE['strFTPPassword'] : "") . '"/>
			</div>
			';
		echo '
			<div class="input-append fullwith">
                <span id="btnFTPConnect" name="btnFTPConnect" class="btn btn-primary" onClick="attachmentFTPConnectionTest();" style="margin-bottom:15px" data-loading-text="' . $_SESSION["strGlobalConnecting"] . '..."/><i class="fa fa-plug"></i> ' . $_SESSION['strToolImporterSelectAtachmentFTPTest'] . '</span>
                <span id="spanFTPTestResult2" class="add-on btn-primary" style="cursor:pointer;height:18px;border-color:#dd7a14;"><i class="icon-minus icon-white"></i></span>

			</div>
			';
		echo '<div id="spanFTPTestResult" class="alert alert-primary" style="color:#000000;font-weight:bold;display:none"></div>';
		echo '</div">';
	}
	?> 
<? } ?>
<div id="tableAtachmentsInfo" class="alert alert-primary" style="display:none;text-align:center;font-weight:bold;color:#990000">
	<span class="btn" onClick="attachmentShowHide(false);" style="cursor:pointer;position: absolute;left: 35px;"><i class="icon-remove"></i> <?=$_SESSION['strGlobalClose']?></span>
	<img src="help/img/toolImporter-XLS-Anexos.jpg" class="img-polaroid"><br>
	<b><?=$_SESSION['strToolImporterSelectAtachmentFolderTip']?></b>
	<br><br>
	<img src="help/img/toolImporter-XLS-Anexos-Folder.jpg" class="img-polaroid"><br>
	<b>
		<?=$_SESSION['strToolImporterSelectAtachmentServerRootFolderTip']?><br>
		<?=$_SESSION['strToolImporterSelectAtachmentServerRootFolderNotePermission']?>
	</b>
</div>
<div class="alert alert-primary" style="text-align:center;font-weight:bold;color:#990000">
	<p><? echo $_SESSION['strToolImporterFilesFormatInfo']; ?></p>
	<p><? 
		//$intMaxploadFileSizeMB = $strings->intMaxploadFileSizeMB;
		$intMaxploadFileSizeMB = trim(str_replace('M', '', ini_get('upload_max_filesize')));
		echo $_SESSION['strToolImporterFilesUploadMaxSize'] . ': ' . $intMaxploadFileSizeMB . ' MB'; 
	?></p>
	<a href="help/importer" target="_blank" style="color:#000000;text-decoration:underline"><? echo $_SESSION['strToolImporterHelp']; ?></a>
</div>

<script>
	function blnIsValidFileExt(val){
		if(!/[^/].(?:xls|xlsx|csv|kml|shp|shx|dbf)/i.test(val)){
			showInfoAlert('<? echo $_SESSION['strErrorInvalidFormat']; ?> SHP + DBF, XLS, XLSX, CSV, KML');
			return;
		} 
		document.getElementById('frmForm').submit();
	}
	
	function importExecute(strExt) { // kml or csv
		// Check if user selected any form to import. Otherwise don't continue
		if (document.getElementById('idForm').value == "") {
			showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectForm']; ?>');
			document.getElementById('idForm').focus();
			return false;
		}
		
		if (strExt == 'csv')  {	
			if (document.getElementById('idLatitude').value == "") {
				showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectLatitudeField']; ?>');
				return false;
				document.getElementById('idLatitude').focus();
			} else if (document.getElementById('idLongitude').value == "") {
				showInfoAlert('<? echo $_SESSION['strToolImporterErrorSelectLongitudeField']; ?>');
				document.getElementById('idLongitude').focus();
				return false;
			}
		}
				
		// http://stratosprovatopoulos.com/web-development/php/ajax-progress-php-script-without-polling/
		// http://www.dave-bond.com/blog/2010/01/JQuery-ajax-progress-HMTL5/
		if (! window.XMLHttpRequest){ alert("Your browser does not support the native XMLHttpRequest object."); return; }
		try{
			var xhr = new XMLHttpRequest();  
			xhr.previous_text = '';							 
			xhr.onerror = function() { alert("[XHR] Fatal Error."); };
			xhr.onreadystatechange = function() {
				try{
					$('#btnImport').button('loading');
					$('#btnFileLoad').button('loading');
					importUpdateProgressBar(0);
					if (xhr.readyState == 4) {
						$('#btnImport').button('reset');
						$('#btnFileLoad').button('reset');
						importUpdateProgressBar();
						if (xhr.responseText) {
							if (xhr.responseText.indexOf('OK') > 0) {
								showInfoAlert("<? echo $intNObjects . ' ' . $_SESSION['strToolImporterInfoSuccess']; ?> " + document.getElementById('idForm').options[document.getElementById('idForm').selectedIndex].text);
							} else {
								showInfoAlert("<?=$_SESSION['strToolImporterLessFieldsMessage']?>");
							}
						}
					} else if (xhr.readyState > 2) {
						var arrStatus = xhr.responseText.split(",");
						//var strResponse = xhr.responseText.substring(xhr.previous_text.length);
						//var arrResult = JSON.parse(strResponse);
						//importUpdateProgressBar(arrResult.idStatus);
						//console.log(arrStatus[arrStatus.length-1]);
						importUpdateProgressBar(arrStatus[arrStatus.length-1]);
						//xhr.previous_text = xhr.responseText;
					}
				} catch (e){}
			};
			xhr.open("GET", "ajax.php?chrAction=II" +
					"&idProject=<? echo $arrProject['idProject']; ?>" +
					"&idUser=<? echo $arrUser['idUser']; ?>" +
					"&idForm=" + document.getElementById('idForm').value + 
					"&strFormName=" + document.getElementById('idForm').options[document.getElementById('idForm').selectedIndex].text + 
					"&strFileName=<? echo $strFileName; ?>" + 
					"&intUTMZone=" + (document.getElementById('intUTMZone') ? document.getElementById('intUTMZone').value : '') +
					"&chrUTMHemisphere=" + (document.getElementById('chrUTMHemisphere') ? document.getElementById('chrUTMHemisphere').value : '') + 
					"&idLatitude=" + (document.getElementById("idLatitude") ? document.getElementById("idLatitude").value : "") +
					"&idLongitude=" + (document.getElementById("idLongitude") ? document.getElementById("idLongitude").value : "") +
					"&idDatumIn=" + (document.getElementById("idDatumIn") ? document.getElementById("idDatumIn").value : "") +
					"&blnNoNullCoords=" + ((document.getElementById('ckbNoNullCoords') && document.getElementById('ckbNoNullCoords').checked) ? '1' : '0') +
					"&idAttachmentFolderName=" + (document.getElementById("idAttachmentFolderName") ? document.getElementById("idAttachmentFolderName").value : "") +
					"&strFTPFolderPath=" + (document.getElementById("strFTPFolderPath") ? document.getElementById("strFTPFolderPath").value : "") +
					"&strFTPUser=" + (document.getElementById("strFTPUser") ? document.getElementById("strFTPUser").value : "") +
					"&strFTPPassword=" + (document.getElementById("strFTPPassword") ? document.getElementById("strFTPPassword").value : "")
					, true);
			xhr.send();      
		} catch (e){ alert("AJAX Not Supported"); }
	}
	
	function importUpdateProgressBar(intCurrent) {	
		var progress = document.getElementById('divProgress');
		if (! intCurrent) {
			progress.style.display = 'none';
			return;
		}
		var intTotal = <? echo $intNObjects ?  $intNObjects  : "0" ; ?>;		
		if ((intCurrent >= 0) && (intCurrent <= intTotal)) {
			progress.style.display = 'block';
			var progressBar = document.getElementById('divProgressBar');
			var progressLabel = document.getElementById('divProgressLabel');
			var intWidth = intTotal > 0 ? (intCurrent/intTotal*100).toFixed(2) : 0;
			progressBar.style.width = intWidth + '%';
			progressLabel.innerHTML = numberWithThousands(intCurrent) + '/' + numberWithThousands(intTotal) + ' (' + intWidth + '%)';
		}
	}
	
	function attachmentShowHide(blnShow) {
		var attach = document.getElementById('tableAtachmentsInfo');
		attach.style.display = blnShow ? 'block' : 'none';
		document.getElementById('divAttachment').style.display = 'block';
	}

	function attachmentFTPConnectionTest() {
		$('#btnFTPConnect').button('loading');
		var spanFTPTestResult = document.getElementById("spanFTPTestResult");
		var spanFTPTestResult2 = document.getElementById("spanFTPTestResult2");
		spanFTPTestResult.style.display = 'none';
		var result = $.ajax({
		  url: 'ajax.php?chrAction=IFT' +
				"&strFTPFolderPath=" + (document.getElementById("strFTPFolderPath") ? document.getElementById("strFTPFolderPath").value : "") +
				"&strFTPUser=" + (document.getElementById("strFTPUser") ? document.getElementById("strFTPUser").value : "") +
				"&strFTPPassword=" + (document.getElementById("strFTPPassword") ? document.getElementById("strFTPPassword").value : "")
		}).always(function() {
			$('#btnFTPConnect').button('reset');
			console.log(result.responseText);
			var retorno = JSON.parse(result.responseText);
			if (retorno['blnResult'] == true) {
				spanFTPTestResult.innerHTML = '<?=$_SESSION['strGlobalSuccess']?>';
				spanFTPTestResult2.innerHTML = '<i class="icon-ok-sign icon-white"></i>';
				spanFTPTestResult2.className="add-on btn-success";
			} else {
				spanFTPTestResult.innerHTML = '<?=$_SESSION['strGlobalFail'] . '<br>' . $_SESSION['strToolImporterSelectAtachmentFTPTestFail']?>';
				spanFTPTestResult2.innerHTML = '<i class="icon-remove-sign icon-white"></i>';
				spanFTPTestResult2.className="add-on btn-danger";
			}
			spanFTPTestResult.style.display = 'block';
		});
	}	
	
	function formChange() {
		var combo = document.getElementById('idForm');
		if (combo.value == 'N') {
        	var reply = prompt('<? echo $_SESSION['stradmManageFormsInsertPrompt']; ?>', '');
			if (! reply) return;
			combo.options[combo.options.length] = new Option(reply, 'N');
			combo.options[combo.options.length-1].selected = true;
		}
	}
</script>